<script>
import _ from 'lodash'

import InlineEditorSingle from '@/../custom_modules/ckeditor5-build-inline-single'
import InlineEditorMulti from '@/../custom_modules/ckeditor5-build-inline-multi'
// import HtmlDataProcessor from '@ckeditor/ckeditor5-engine/src/dataprocessor/htmldataprocessor'

// const RawTextProcessor = class {
//   constructor (options = {}) {
//     this._htmlDP = new HtmlDataProcessor()
//     // this._wantBr = options.br === true
//     // console.log(this._wantBr)
//   }

//   toView (data) {
//     data = data === null ? '' : data
//     // // if (this._wantBr) {
//     // data = data.split('%br%').join('</p><p>')
//     // data = data.split('%nbsp%').join(' ')

//     // data = data.split('<br/>').join('</p><p>')
//     // // }
//     // data = data.split('</p><p> ').join('</p><p>\u00A0')
//     // // data = data.replace( /\u00A0/g, '&nbsp;')
//     // data = data.slice(-1) === ' ' ? data.slice(0, -1) + '\u00A0' : data
//     // data = data.charAt(0) === ' ' ? '\u00A0' + data.substr(1) : data
//     // // data = data.charAt(data.length - 1) === ' ' ? data.substr(0, data.length - 1) + '\u00A0' : data

//     // // console.log('data', data.length)
//     // data = data.replace(/ {2}/g, ' \u00A0')
//     // // console.log('data', data.length)
//     // data = unescapeHTML(data)
//     return this._htmlDP.toView('<p>' + data + '</p>')
//   }

//   toData (viewFragment) {
//   //   // console.log(viewFragment)
//   //   // const html = this._htmlDP.toData(viewFragment).replace('</p><p>', '__br__')
//   //   // return viewToPlainText(this._htmlDP.toView(html))
//   //   // console.log(viewFragment)
//   //   let html = this._htmlDP.toData(viewFragment)
//   //   // console.log('html', html)
//   //   // if (this._wantBr) {
//   //   console.log('text', html)
//   //   html = html.split('</p><p>').join('%br%')
//   //   // }
//   //   html = html.slice(-1) === ' ' ? html.slice(0, -1) + '%nbsp%' : html
//   //   html = html.charAt(0) === ' ' ? '%nbsp%' + html.substr(1) : html
//   //   html = html.replace(/ {2}/g, ' %nbsp%')
//   //   html = html.replace(/&nbsp;/g, '%nbsp%')

//   //   html = html.replace('<p>', '')
//   //   html = html.replace('</p>', '')

//   //   // const elem = window.document.createElement('div')
//   //   // elem.innerHTML = html
//   //   // let text = elem.innerText
//   //   // let text = escapeHTML(html)
//   //   let text = html
//   //   // console.log('text', text)
//   //   // if (this._wantBr) {
//   //   text = text.split('%br%').join('<br/>')
//   //   // }
//   //   text = text.split('%nbsp%').join(' ')
//   //   return text
//     const html = this._htmlDP.toData(viewFragment)
//     return html
//   }
// }

// function RawText (editor) {
//   editor.data.processor = new RawTextProcessor()
// }

export default {
  name: 'inline-editor',

  render: createElement => createElement('div', {
    class: { 'editable-input': true, 'editable-input-with-br': this.br, 'editable-input-read-only': this.readOnly }
    // on: {
    //   click: function (event) {
    //     event.stopPropagation()
    //   }
    // }
  }),

  props: {
    config: {
      default: () => {},
      required: false,
      type: Object
    },

    br: {
      default: () => false,
      required: false,
      type: Boolean
    },

    readOnly: {
      default: () => false,
      required: false,
      type: Boolean
    },

    type: {
      required: false,
      type: String,
      default: 'single'
    },

    value: {
      required: false
    },

    placeholder: {
      required: false,
      type: String,
      default: ''
    }
  },

  data () {
    return {
      instance: null,
      editors: {
        single: InlineEditorSingle,
        multi: InlineEditorMulti
      },
      output: null
    }
  },

  watch: {
    value (val) {
      this.output = this.format(val)
      console.log('output', this.output)

      try {
        if (this.instance) {
          this.update(this.output)
        }
      } catch (e) {}
    }
  },

  computed: {
    editor () {
      return this.editors[this.type]
    },

    // configuration () {
    //   const buildConfig = _.get(this.editor, 'build.config', {})

    //   let configuration = {}
    //   if (this.type === 'single' && !this.br) {
    //     configuration.removePlugins = [ 'BrPlugin' ]
    //     configuration.toolbar = { items: _.without(_.get(buildConfig, 'toolbar.items', []), 'br') }
    //   }
    //   // console.log('---')
    //   // console.log('type', this.type)
    //   // console.log('br', this.br)
    //   // console.log(buildConfig)
    //   // console.log({ ...buildConfig, ...configuration, ...this.config })
    //   return { ...buildConfig, ...configuration, ...this.config }
    // }

    configuration () {
      const buildConfig = _.get(this.editor, 'build.config', {})
      // const buildPlugins = _.get(this.editor, 'build.plugins', [])

      let configuration = {}
      if (this.type === 'single' && !this.br) {
        configuration.removePlugins = [ 'BrPlugin' ]
        configuration.toolbar = { items: _.without(_.get(buildConfig, 'toolbar.items', []), 'br') }
      }
      // console.log('---')
      // console.log('type', this.type)
      // console.log('br', this.br)
      // console.log(buildConfig)
      // console.log({ ...buildConfig, ...configuration, ...this.config })
      // return configuration

      // console.log('plugins', [
      //   RawText,
      //   ...buildPlugins
      // ])

      return {
        // plugins: [
        //   RawText
        //   // ...buildPlugins
        // ],
        ...buildConfig,
        ...configuration,
        ...this.config
      }
    }
  },

  methods: {
    create () {
      if (this.instance == null) {
        const type = this.type
        const editors = this.editors

        if (!Object.keys(editors).length) {
          throw new Error(`There are no CKEditor 5 implementations.`)
        }

        const editor = this.editor

        if (editor == null) {
          throw new Error(`Wrong key '${type}'. Allowed keys: ${Object.keys(editors)}`)
        }

        editor
          .create(this.$el, this.configuration)
          .then(editor => {
            // console.log(Array.from(editor.ui.componentFactory.names()))
            this.instance = editor

            const instance = this.instance
            instance.isReadOnly = this.readOnly
            // instance.placeholder = 'wolololo'
            instance.model.document.on('change', this.onChange)
            instance.model.document.on('blur', this.onBlur)
            console.log('aaa', this.format(this.output))
            instance.setData('<p>' + this.output + '</p>', { internal: true })

            if (editor.isEmpty) {
              this.$el.setAttribute('data-empty', true)
            } else {
              this.$el.removeAttribute('data-empty')
            }

            editor.on('change:isEmpty', () => {
              if (editor.isEmpty) {
                this.$el.setAttribute('data-empty', true)
              } else {
                this.$el.removeAttribute('data-empty')
              }
            })
          })
          .catch(error => {
            console.log(error)
          })
      }
    },

    destroy () {
      const instance = this.instance

      if (instance != null) {
        instance.destroy()
      }
    },

    onChange: _.throttle(function () {
      const output = this.instance.getData()
      if (this.output !== output) {
        this.$emit('input', output)
      }
    }, 1000),

    onBlur () {
      const output = this.instance.getData()
      if (this.output !== output) {
        this.$emit('input', output)
      }
    },

    format (val) {
      val = val || ''
      // console.log('---br', this.br)
      // console.log('---val', val)
      // console.log('---rep', val.replace(/<br\/>/g, '</p><p>'))
      val = this.br ? val.replace(/<br\/>/g, '</p><p>') : val
      // val = this.br ? val.replace(/<p>&nbsp;<\/p>/g, '') : val
      return val
    },
    // onChange () {
    //   const output = this.instance.getData()

    //   if (this.output !== output) {
    //     this.$emit('input', output)
    //   }
    // },
    update (val) {
      let html = this.instance.getData()
      if (html !== val) {
        this.instance.setData(val, { internal: false })
      }
    }
  },

  mounted () {
    this.create()
    if (this.placeholder) {
      this.$el.style.setProperty('--editor-placeholder', '"' + this.placeholder + '"')
    }
  },

  beforeDestroy () {
    this.destroy()
  },

  created () {
    this.output = this.format(this.value)
    // if (this.placeholder) {
    //   this.$el.style.setProperty('--editor-placeholder', this.placeholder)
    // }
  }
}
</script>

<style lang="scss" scoped>
  .editable-input {
    --editor-placeholder: '';
  }

  .editable-input[data-empty]::before {
    content: var(--editor-placeholder);
    position: absolute;
    display: block;
    color: #aaa;
    font-weight: bold;
  }
</style>
